/******************************************************************************/
/* MCrypt, by LoRd_MuldeR <MuldeR2@GMX.de>                                    */
/* This work has been released under the CC0 1.0 Universal license!           */
/******************************************************************************/

#ifndef INC_PLATFORM_H
#define INC_PLATFORM_H

#ifdef _WIN32
#define MAIN wmain
#define CHR wchar_t
#define _T(X) L##X
#define STRLEN(X) wcslen((X))
#define STRICMP(X,Y) _wcsicmp((X),(Y))
#define FPUTS(X,Y) fputws((X),(Y))
#define FPRINTF(X,Y,...) fwprintf((X),(Y),__VA_ARGS__)
#define FOPEN(X,Y) _wfopen((X),(Y))
#define FILENO(X) _fileno((X))
#define FSTAT64(X,Y) _fstati64((X),(Y))
#define STAT64_T struct _stati64
#define ISUPPER(X) iswupper((X))
#define ISLOWER(X) iswlower((X))
#define ISDIGIT(X) iswdigit((X))
#define ISGRAPH(X) iswgraph((X))
#ifdef __MINGW32__
#define PRISTR "ls"
#define PRIstr "hs"
#define PRIwcs "ls"
#else
#define PRISTR "s"
#define PRIstr "S"
#define PRIwcs "s"
#endif
#else
#define MAIN main
#define CHR char
#define _T(X) X
#define STRLEN(X) strlen((X))
#define STRICMP(X,Y) strcasecmp((X),(Y))
#define FPUTS(X,Y) fputs((X),(Y))
#define FPRINTF(X,Y,...) fprintf((X),(Y),__VA_ARGS__)
#define FOPEN(X,Y) fopen((X),(Y))
#define FILENO(X) fileno((X))
#define FSTAT64(X,Y) fstat64((X),(Y))
#define STAT64_T struct stat64
#define ISUPPER(X) isupper((X))
#define ISLOWER(X) islower((X))
#define ISDIGIT(X) isdigit((X))
#define ISGRAPH(X) isgraph((X))
#define PRISTR "s"
#define PRIstr "s"
#define PRIwcs "ls"
#endif

#define T(X) _T(X)

#endif
