/******************************************************************************/
/* MCrypt, by LoRd_MuldeR <MuldeR2@GMX.de>                                    */
/* This work has been released under the CC0 1.0 Universal license!           */
/******************************************************************************/

#ifndef INC_UTILS_H
#define INC_UTILS_H

#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>
#include "platform.h"

#ifndef CP_UTF8
#define CP_UTF8 65001
#endif

void erase(void *const ptr, const size_t length);
uint64_t get_file_size(FILE* const file);
char* utf16_to_bytes(const CHR *const input, const uint32_t code_page);

#endif
